<template>
    <div class="container">
        <div class="row">
            <div class="col-md-3">
                <div class="accordion" id="accordionCountry">
                  <div class="card" v-for="(country,country_index) in dictionary">
                    <div class="card-header" :id="'headingCountry'+country.id">
                      <h5 class="mb-0">
                        <button class="btn btn-link collapsed" type="button" data-toggle="collapse" :data-target="'#collapseCountry'+country.id">
                          {{country.name}}
                        </button>
                      </h5>
                    </div>

                    <div :id="'collapseCountry'+country.id" class="collapse" data-parent="#accordionCountry">
                      <div class="card-body">
                        <div class="accordion" id="accordionCity">
                          <div class="card" v-for="city in country.cities">
                            <div class="card-header" :id="'headingCity'+city.id">
                              <h5 class="mb-0">
                                <button class="btn btn-link" type="button" data-toggle="collapse" :data-target="'#collapseCity'+city.id">
                                  {{city.name}}
                                </button>
                              </h5>
                            </div>
                            <div :id="'collapseCity'+city.id" class="collapse" data-parent="#accordionCity">
                              <ul class="list-group list-group-flush">
                                <li v-for="client in city.clients" class="list-group-item list-group-item-action" v-on:click="showSelected(client)">{{client.fullname}}</li>
                              </ul>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
            </div>
            <div class="col-md-9">
                <yandex-map 
                    :coords="coordinates"
                    zoom="10"
                    style="width: 100%; height: 600px;"
                    :behaviors="['drag']"
                    :controls="['default']">

                    <template v-if="showTrack">
                        <ymap-marker
                              :marker-id="current.id"
                              marker-type="polyline"
                              :coords="positions"
                            ></ymap-marker>
                            <ymap-marker
                              :marker-id="'start'+current.id"
                              marker-type="placemark"
                              :coords="start_position"
                              hint-content="Start"
                              :balloon="{header: current.fullname, body: current.email, footer: current.phone}"
                              :icon="{color: 'blue'}"
                            ></ymap-marker>
                            <ymap-marker
                              :marker-id="'finish'+current.id"
                              marker-type="placemark"
                              :coords="finish_position"
                              hint-content="Finish"
                              :balloon="{header: current.fullname, body: current.email, footer: current.phone}"
                              :icon="{color: 'red'}"
                            ></ymap-marker>
                    </template>
                    <template v-else>
                        <ymap-marker v-for="client in clients"
                                :key='client.id'
                              :marker-id="client.id"
                              marker-type="placemark"
                              :coords="client.latest_position.position.coordinates"
                              :hint-content="client.fullname"
                              :balloon="{header: client.fullname, body: client.email, footer: client.phone}"
                            ></ymap-marker>
                    </template> 
                </yandex-map>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        created: function () {
            this.refresh();
        },
        data: function(){
            return {
                dictionary: [],
                clients: [],
                positions: [],
                current: null,
                coordinates: [56.83333, 60.58333],
                showTrack: false,
                start_position: [],
                finish_position: []
            };
        },
        methods: {
            refresh: function () {
                axios.get('/api/data').then((response) => {
                    this.dictionary = response.data;
                });
                axios.get('/api/client').then((response) => {
                    this.clients = response.data.filter(function(client){
                        return !! client.latest_position;
                    });
                });
            },
            showSelected: function(client) {
                this.current = client;
                axios.get('/api/position/'+client.id).then((response) => {
                    this.positions = response.data.map(function(position){
                        return position.position.coordinates;
                    });
                    this.start_position = _.last(this.positions);
                    this.finish_position = _.first(this.positions);
                    this.coordinates = this.finish_position;
                    this.showTrack = true;
                });
            }
        }
    }
</script>
